import requests
import json
import random
user_email = input('email: ')
user_password = input('password: ')

refs_count = int(input('сколько тебе накрутить? '))

def get_random_string(length):
    letters = "abcdefghijklmopqrstuvwxyz"
    result_str = ''.join(random.choice(letters) for i in range(length))
    return result_str


print("getting token data...")
token_data = requests.post(
    "https://rethink.software/api/v2/tokens.create",
    json={"twoFactorAuthToken": "", "usersEmail": user_email,
          "usersPassword": user_password}
)

secret_token = token_data.json()['data'][0]['secret']
user_id = token_data.json()['data'][0]['user']['id']

print("getting user workspace data...")
user_workspace_data = requests.get(
    "https://rethink.software/api/v2/workspacesUsers.read",
    params={"usersId": user_id},
    cookies={"token": secret_token}
)

referrer_id = user_workspace_data.json()['data'][0]['workspace']['referrerId']
workspace_id = user_workspace_data.json()['data'][0]['workspace']['id']

print("генерируем список фейковых адресов...")
referrals_fake_emails_list = []
for x in range(refs_count):
    random_domain = get_random_string(6)
    random_email = get_random_string(5)
    referrals_fake_emails_list.append({"email": f"{referrer_id[:5]}{random_email}@{random_domain}"})

print("генерируем рефералки на каждый ящик...")
prep = json.dumps({"referrals": referrals_fake_emails_list, "referrerId": referrer_id})
created_refs = requests.post(
    "https://rethink.software/api/v2/referrals.create",
    data=prep,
    cookies={"token": str(secret_token), "workspacesId": str(workspace_id)})

print("создаем фейковых юзеров...")
for fake_email in referrals_fake_emails_list:
    try:
        fake_user_data = requests.post(
            "https://rethink.software/api/v2/users.create",
            json={"name": "", "givenName": get_random_string(5), "familyName": get_random_string(5), "email": fake_email['email'], "password": "qweqwe321", "mobileSignupBounce": False, "timezone": "Europe/Moscow"})
        fake_user_data.raise_for_status()
    except requests.exceptions.RequestException as e:
        print(f"{e.response.text} : {fake_email['email']}")
        pass
    else:
        fake_user_completed_id = fake_user_data.json()['data'][0]['id']
        fake_user_token = fake_user_data.json()['data'][0]['token']['secret']

        print(f"подтверждаем ящик: {fake_email['email']}")
        ref_complete_data = requests.post(
            "https://rethink.software/api/v2/referrals.complete",
            json={"completedAccountId": fake_user_completed_id, "referrerId": referrer_id},
            cookies={"token": fake_user_token}
        )
        print(ref_complete_data.status_code)
